#include <os.h>
#include <nspireio.h>

int main(int argc, char **argv)
{
	rshell_load();
	
	FILE *from, *to;
	char ch;


	if(argc != 3)
	{
		c_swrite("USAGE: %s SOURCE DESTINATION\n",argv[0]);
		c_swrite("Copies a file from SOURCE to DESTINATION.\n");
		goto end;
	}
	
	// Open source file
	from = fopen(argv[1], "rb");
	if(!from)
	{
		c_swrite("Error opening source file: %s\n",strerror(errno));
		goto end;
	}
	
	// Open dest file
	to = fopen(argv[2], "wb");
	if(!to)
	{
		c_swrite("Error opening destination file: %s\n",strerror(errno));
		goto end;
	}
	
	// Copy file
	while(!feof(from))
	{
		ch = fgetc(from);
		if(ferror(from))
		{
			c_swrite("Error reading source file.\n");
			goto end;
		}
		if(!feof(from)) fputc(ch, to);
		if(ferror(to))
		{
			c_swrite("Error writing destination file.\n");
			goto end;
		}
	}

	if(fclose(from)==EOF)
	{
		c_swrite("Error closing source file.\n");
		goto end;
	}

	if(fclose(to)==EOF)
	{
		c_swrite("Error closing destination file.\n");
		goto end;
	}
	
end:
	rshell_save();
	return 0;
}