#include <os.h>
#include <nspireio.h>

#define BINDIR "\\documents\\bin\\"
#define PRGMSIG "PRG"
#define RSHELLSIG "RSH"

// Needed for argv
char *my_strtok(char *string, const char *separator)
{
    char *s1, *s2;
    static char *str_save;
	
    if (string == NULL)
	{
        string = str_save;
        if (string == NULL) return (char *)NULL;
    }
    s1 = string + strspn(string, separator);
    if (*s1 == '\0')
	{
        str_save = NULL;
        return (char *)NULL;
    }
    s2 = strpbrk(s1, separator);
    if (s2 != NULL)
	{
        *s2++ = '\0';
	}
    str_save = s2;

    return s1;
}

int main(int argc, char** argv)
{
	// Disable interrupts for RS232 communication
	//unsigned intmask = TCT_Local_Control_Interrupts(0);
	
	char path[100];
	char path2[100];
	char buf[100];
	char* n_argv[20];
	char file[100];
	int n_argc;
	
	c_init(WHITE,BLACK);
	
	while(1)
	{
		// Always read current dir
		NU_Current_Dir("A:",path);
		c_swrite("A:%s>",path);
		
		/* fflush(stdin);
		fgets(buf,100,stdin); */
		c_read(buf);
		
		
		
		// Making C's argc and argv ready
		n_argc = 0;
		n_argv[0] = my_strtok(buf," \r\n");

		while(n_argv[n_argc] != NULL)
		{
			n_argv[++n_argc] = my_strtok(NULL," \r\n");
		}
		
		// Checking for rshell commands
		if(strcmp(n_argv[0],"cd") == 0)
		{
			// Command: Change directory
			if(chdir(n_argv[1]) != 0)
			{
				c_swrite("Error: %s\n",strerror(errno));
			}
			continue;
		}
		if(strcmp(n_argv[0],"exit") == 0)
		{
			// Command: Exit rshell
			break;
		}
		
		strcpy(file,n_argv[0]);
		if(strstr(file,".tns") == NULL)
		{
			strcat(file,".tns");
		}
		// Search file
		struct stat fstat;
		// Check for absolute path
		if(stat(file,&fstat) != 0)
		{
			// Check in current path
			strcpy(path2,path);
			strcat(path2,file);
			if(stat(path2,&fstat) != 0)
			{
				// Check in BINDIR
				strcpy(path2,BINDIR);
				strcat(path2,file);
				if(stat(path2,&fstat) != 0)
				{
					c_swrite("Error: %s\n",strerror(errno));
					continue;
				}
			}
		}
		else
		{
			strcpy(path2,file);
		}
		
		// Open file
		FILE *docfile = fopen(path2,"rb");
		if(!docfile)
		{
			c_swrite("Error: %s\n",strerror(errno));
			continue;
		}

		// Allocate memory for file
		void *docptr = malloc(fstat.st_size);
		if(!docptr)
		{
			c_swrite("Error: %s\n",strerror(errno));
			continue;
		}

		// Read file into memory
		if(!fread(docptr,fstat.st_size,1,docfile))
		{
			c_swrite("Error: %s\n",strerror(errno));
			continue;
		}
		
		// Check if executable
		if(strcmp(PRGMSIG,docptr) && strcmp(RSHELLSIG,docptr))
		{
			c_write("Error: File is not executable\n");
			fclose(docfile);
			free(docptr);			
			continue;
		}
		
		if(strcmp(PRGMSIG,docptr) == 0)
		{
			c_write("Note: The program you want to execute is not intended for use with rshell.\n");
			sleep(1000);
		}
		
		// Close file
		if(fclose(docfile) == EOF)
		{
			c_swrite("Error: %s\n",strerror(errno));
			continue;
		}
		
		rshell_save();
		
		clear_cache();
		// Launch it!
		((void (*)(int, char **))(docptr + sizeof(PRGMSIG)))(n_argc, n_argv);
		
		rshell_load();
		c_draw();
		// Clean up...
		free(docptr);
		
		
		// ...and do it all again.
	}
	
	// wait to prevent rshell being launched again immediately
	wait_no_key_pressed();
	
	// Restore interrupts
	//TCT_Local_Control_Interrupts(intmask);
	return 0;
}